Getting Started with the Kendo UI for Angular Sortable

This guide provides the information you need to start using the Kendo UI for Angular Sortable—it includes instructions about the available installation approaches, the required dependencies, the code for running the project, and links to additional resources.

The Sortable Package is part of Kendo UI for Angular, a professional grade UI library with 100+ components for building modern and feature-rich applications. To try it out sign up for a free 30-day trial.

After the completion of this guide, you will be able to achieve an end result as demonstrated in the following example.

Example
View Source
Change Theme:

Setting Up Your Angular Project

Before you start with the installation of any Kendo UI for Angular control, ensure that you have a running Angular project. The prerequisites to accomplish the installation of the components are always the same regardless of the Kendo UI for Angular package you want to use, and are fully described in the section on setting up your Angular project.

Installing the Component

You can choose to use either of the following two approaches for installing the Kendo UI for Angular package and the styles you want to apply:

Quick Setup with Angular CLI

The quick setup presents an automatic approach for adding packages with Angular CLI through the ng-add command. It is suitable for saving time and efforts as ng-add executes in a single step a set of otherwise individually needed commands.

To add the Kendo UI for Angular Sortable package, run the following command:

ng add @progress/kendo-angular-sortable

As a result, the ng-add command will perform the following actions:

  • Add the @progress/kendo-angular-sortable package as a dependency to the package.json file.
  • Import the SortableModule in the current application module.
  • Register the Kendo UI Default theme in the angular.json file.
  • Add all required peer dependencies to the package.json file.
  • Trigger npm install to install the theme and all peer packages that are added.

Manual Setup

The manual setup provides greater visibility and better control over the files and references installed in your Angular application. You can install the required peer dependencies and a Kendo UI theme by running separate commands for each step and import the desired component modules in your application root or feature module.

  1. Install the Sortable package together with its dependencies by running the following command:

    npm install --save @progress/kendo-angular-sortable @angular/common @angular/core @progress/kendo-angular-l10n @progress/kendo-angular-common @progress/kendo-licensing @progress/kendo-licensing
  2. Тo add the Sortable component, import the SortableModule in your root application or feature module.

    import { NgModule } from '@angular/core';
    import { BrowserModule } from '@angular/platform-browser';
    import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
    import { SortableModule } from '@progress/kendo-angular-sortable';
    import { AppComponent } from './app.component';
    
    @NgModule({
        imports: [BrowserModule, BrowserAnimationsModule, SortableModule ],
        declarations: [AppComponent],
        bootstrap: [AppComponent]
    })
    
    export class AppModule {}
  3. The next step is to style the component by installing one of the available Kendo UI themes—Kendo UI Default, Kendo UI Material, or Kendo UI Bootstrap.

    3.1 To start using a theme, install its package through NPM.

    • Default theme

      npm install --save @progress/kendo-theme-default
    • Bootstrap theme

      npm install --save @progress/kendo-theme-bootstrap
    • Material theme

      npm install --save @progress/kendo-theme-material

    3.2 After the theme package is installed, reference it in your project. You can include kendo-themes in your project in one of the following ways:

Using the Component

  1. After successfully installing the Sortable package and importing its module, add the following code in the app.component.html file:

    <kendo-sortable
        [kendoSortableBinding]="items"
        [animation]="true"
        itemClass="item"
        activeItemClass="item active"
    >
    </kendo-sortable>
  2. Bind the kendoSortableBinding directive to an array of strings by adding the following code in the app.component.ts file:

    public items: string[] = [
        "Item 1", "Item 2", "Item 3", "Item 4",
        "Item 5", "Item 6", "Item 7", "Item 8"
    ];
  3. Style the Sortable items by setting the itemClass and activeItemClass properties to the respective CSS classes. For example add the following styles:

    .item {
        background-color: #bfe7f9;
        color: #1494d0;
        border: 1px solid #fff;
        width: 200px;
        line-height: 68px;
        font-size: 16px;
        text-align: center;
        cursor: move;
    }
    
    .item.active {
        background-color: #27aceb;
        color: #fff;
        border-color: #27aceb;
        z-index: 10;
        width: 200px;
    }
  4. Build and serve the application by running the following command in the root folder.

    ng serve
  5. Point your browser to http://localhost:4200 to see the Kendo UI for Angular Sortable component on the page.

Activating Your License Key

As of December 2020, using any of the UI components from the Kendo UI for Angular library requires either a commercial license key or an active trial license key. If your application does not contain a Kendo UI license file, activate your license key.

Next Steps

Dependencies

The following table lists the specific functionalities that are provided by each of the Sortable dependencies as per package:

Package NameDescription
@angular/commonProvides the commonly-needed services, pipes, and directives provided by the Angular team. For more information, refer to the official Angular documentation.
@angular/coreContains critical runtime parts of the Angular framework that are needed by every application. For more information, refer to the official Angular documentation.
@progress/kendo-angular-l10nProvides the globalization features of Kendo UI for Angular.
@progress/kendo-angular-commonContains common utilities that are needed by every Kendo UI for Angular component.
@progress/kendo-licensingContains the kendo-ui-license CLI Tool for license management and the validatePackage function and type definitions that are used by licensed packages.
rxjsProvides the RxJS library for reactive programming which uses Observables for an easier composition of asynchronous or callback-based code.

Learning Resources

Getting Started with the KendoReact Sortable
Premium

This guide provides essential information about using the KendoReact Sortable package—you will learn how to install the Sortable package, add a Sortable component to your project, style the component, and activate your license.

ninja-iconThe Sortable is part of KendoReact premium, an enterprise-grade UI library with 120+ free and premium components for building polished, performant apps. Test-drive all features with a free 30-day trial.Start Free Trial

After completing this guide, you will be able to reproduce the following example.

Change Theme
Theme
Loading ...

Setting Up Your React Project

Before you install the KendoReact Sortable, make sure that you have a running React project. The easiest way to set up a React project is to use the Create React App approach that is described in the Get Started with KendoReact article.

Installing the Sortable Package

All KendoReact packages are distributed through npm and offer a similar installation experience. To use the Sortable component, start with the installation of the Sortable npm package and its dependencies. Use Node.js v5.0.0 or later.

sh
npm i @progress/kendo-react-sortable

Importing the Component

After installing the package, import the Sortable component in the React App.

In the src/App.js file of your React project, import the Sortable component from the Sortable package.

jsx
// ES2015 module syntax
import { Sortable } from "@progress/kendo-react-sortable";
jsx
// CommonJS format
const { Sortable } = require('@progress/kendo-react-sortable');

Using the Component

  1. Create a state variable for the sortable items.

    jsx
    const [data, setData] = React.useState([
        {
            id: 1,
            text: 'item1'
        },
        {
            id: 2,
            text: 'item2'
        },
        {
            id: 3,
            text: 'item3'
        }
    ]);
  2. Create a component that you will use for each of the items in the Sortable.

    jsx
    const SortableItemUI = (props) => {
        const { attributes, dataItem, forwardRef, isActive, style } = props;
    
        return (
            <div ref={forwardRef} {...attributes} style={{ ...getBaseItemStyle(isActive), ...style }}>
                {dataItem.text}
            </div>
        );
    };
  3. Add styles for the item based on its isActive status.

    jsx
    const getBaseItemStyle = (isActive) => ({
        height: 70,
        lineHeight: '68px',
        fontSize: '16px',
        textAlign: 'center',
        outline: 'none',
        border: '1px solid',
        cursor: 'move',
        display: 'block',
        width: 200,
        background: isActive ? '#27aceb' : '#bfe7f9',
        color: isActive ? '#fff' : '#1494d0',
        borderColor: isActive ? '#27aceb' : '#fff'
    });
  4. Handle the onDragOver) event of the Sortable. Use that event to get the new order of the item after sorting.

    jsx
    const onDragOver = (event) => {
        setData(event.newState);
    };
  5. To style the Sortable, install and import the Default theme, which is one of the three beautiful themes for KendoReact.

    5.1. Install the Default theme package.

    sh
    npm i @progress/kendo-theme-default

    5.2. Import the CSS file from the package in src/App.js. Add this import before your existing App.css import.

    jsx
    import '@progress/kendo-theme-default/dist/all.css';
  6. Build and run the application by typing the following command in the root folder of your project:

    sh
    npm start
  7. Navigate to http://localhost:3000 to see the KendoReact Sortable component on the page.

Activating Your License Key

Using any of the UI components in the KendoReact library requires either a commercial license key or an active trial license key.

Follow the instructions on the KendoReact My License page to activate your trial or commercial license. You can skip this step if your application already contains a KendoReact license file.

Dependencies

The Sortable package requires you to install the following peer dependencies in your application:

Package NameDescription
react 16.8.2*Contains the functionality necessary to define React components.
react-domContains the React renderer for the web.
@progress/kendo-licensingContains the internal infrastructure related to licensing.

Learning Resources